
package com.picfun.chargermonitor;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.os.Message;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.picfun.chargermonitor.USBAccessoryManager;
import com.picfun.chargermonitor.USBAccessoryManagerMessage;
import android.os.Handler;

public class ChargerMonitor extends Activity {
	// GUI用変数、定数定義
	private final static int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
	private static Button Charge;
	private static TextView text, text1, text2, text3;
	private static MyView graph;
	// USB関連クラス変数、定数定義
	private USBAccessoryManager accessoryManager;			// アクセサリインスタンス定義
	private final static int USBEvent = 0;
	private byte[] commandPacket = new byte[64];			// USB送受信バッファ Max64byte
	// USB制御コマンド定数定義    
	private static final byte OKCHECK 		= 0x01;		// 接続確認コマンド
	private static final byte START   		= 0x02;		// 収集開始コマンド
	private static final byte MsrPower  		= 0x03;		// データ収集コマンド
	private static final byte MsrShunt  		= 0x04;		// データ収集コマンド	
	private static final byte MsrBattery 		= 0x05;		// データ収集コマンド
	private static final byte MsrDischarge  	= 0x06;		// データ収集コマンド	
	private static final byte DISCONNECT 		= 0x7F;		// 切り離し要求
	// バッファ、一般変数定義
	private static final int MAXSIZE = 720;
	private float[] PowerVolt = new float[MAXSIZE];
	private float[] ShuntVolt = new float[MAXSIZE];
	private float[] BatteryVolt = new float[MAXSIZE];
	private float[] ChargeCurrent = new float[MAXSIZE];
	private float[] DischargeVolt = new float[MAXSIZE];
	private byte[] Data = new byte[MAXSIZE * 2];
	private static int setPoint, i;
	private static int Index, Counter;
		
	/***** 最初に実行されるメソッド　GUIの表示 **********************/
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE); 
        
        /*** レイアウト定義　*******/     
        LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.HORIZONTAL);
        setContentView(layout); 
        	// サブレイアウト
        	LinearLayout layout2 = new LinearLayout(this);
            layout2.setOrientation(LinearLayout.VERTICAL);
            layout2.setGravity(Gravity.LEFT); 
             	// 見出しテキスト表示             
    	        text = new TextView(this);
    	        text.setLayoutParams(new LinearLayout.LayoutParams(65,WC));
    	        text.setTextSize(10f);
       	        text.setTextColor(Color.MAGENTA);    	        
    	        text.setText(" 充放電");
    	        layout2.addView(text);

       	    	// ボタン生成    	    	
    	    	LinearLayout.LayoutParams params2 = new LinearLayout.LayoutParams(60, WC);
      	    	params2.setMargins(0,10, 0,0);
      	    	Charge = new Button(this);						// 充電開始ボタン
      	    	Charge.setBackgroundColor(Color.YELLOW);
      	    	Charge.setTextSize(12f);
      	    	Charge.setTextColor(Color.BLACK);
      	    	Charge.setText("開始");
      	    	Charge.setLayoutParams(params2);
      	    	layout2.addView(Charge);
     	    	
    	    	// デバッグ用メッセージボックス生成
    	    	LinearLayout.LayoutParams params3 = new LinearLayout.LayoutParams(60, WC);
      	    	params3.setMargins(5, 100, 0,0);     	    	
    	    	LinearLayout.LayoutParams params4 = new LinearLayout.LayoutParams(60, WC);
      	    	params4.setMargins(0, 5, 0,0);	
    	    	text1 = new TextView(this);
      	        text1.setLayoutParams(params3);
      	        text1.setTextSize(8f);
      	        text1.setText("デバッグメッセージ No1 ");
      	        layout2.addView(text1);   	        
      	        text2 = new TextView(this);
             	text2.setTextSize(8f);
      	        text2.setLayoutParams(params4);
    	        text2.setText("デバッグメッセージ No2");
    	        layout2.addView(text2); 
    	        text3 = new TextView(this);
    	        text3.setTextSize(8f);
    	        text3.setLayoutParams(params4);
    	        text3.setText("デバッグメッセージ No3");
    	        layout2.addView(text3); 	        
    	layout.addView(layout2);
    	// グラフ描画
    	graph = new MyView(this);
        layout.addView(graph); 
        // ボタンイベントリスナ生成
        Charge.setOnClickListener((OnClickListener) new ContStart());
	        
    	/*********** USBクラス　ハンドラ生成 *********************/        
       	accessoryManager = new USBAccessoryManager(handler, USBEvent);   	       	
    }

    /********** アプリケーション遷移イベント処理　********************/
	@Override
	public void onStart() {
		super.onStart();
		text1.setTextColor(Color.GREEN);
		text1.setText("アプリケーション起動");	
	}
    @Override
    public void onResume() {
    	super.onResume();
		text2.setTextColor(Color.GREEN);
		text2.setText("アプリケーション再起動");
	    accessoryManager.enable(this, getIntent());			// USB再接続実行		
    }
    @Override
    public void onPause() {
    	super.onPause();
		commandPacket[0] = (byte)DISCONNECT;				// 切り離し要求
		accessoryManager.write(commandPacket);   		
    	accessoryManager.disable(this);						// USB切り離し実行
    	text2.setTextColor(Color.YELLOW);
    	text2.setText("アプリケーション一旦停止");
    }  
    
    /********** USBイベントハンドル  *********/
    private Handler handler = new Handler() {
    	@Override
    	/* USBライブラリ応答メッセージ処理 */
    	public void handleMessage(Message msg) {
    		switch(((USBAccessoryManagerMessage)msg.obj).type) {
				case CONNECTED:
					text1.setTextColor(Color.GREEN);
					text1.setText("USBホストが接続されました");			
					break;
				case READY:
					text2.setTextColor(Color.GREEN);
					text2.setText("USBホスト正常接続完了");				
					break;
				case DISCONNECTED:
					text2.setTextColor(Color.RED);
					text2.setText("USBホストが切り離されました");
					break;								
				case READ:
					if(accessoryManager.isConnected() == false) {
						text1.setTextColor(Color.YELLOW);
						text1.setText("USBホストが接続なし、終了します！");
						return;
					}
					if(accessoryManager.available() > 2) {			// 受信データ残チェック3バイト以上か
						accessoryManager.read(commandPacket);		// 受信データ取り出し64バイト一括
						// USB受信メッセージごとの処理
						Process();
					}
					break;
				default:break;
    		}
		}							
    };   
    
    /***** データ表示処理関数 *******/
    private void Process(){
		switch(commandPacket[0]) {
			case OKCHECK:											// 接続確認コマンドの場合
				if((commandPacket[1] == 'O')&&(commandPacket[2] == 'K'))
					text3.setText("正常接続確認");
				else
					text3.setText("接続確認失敗");							
				break;
			case START:
				Index = commandPacket[1]*128+commandPacket[2];		// データ数取得
				setPoint = (int)commandPacket[3];
				Counter = 0;
				commandPacket[0] = MsrPower;						// 最初のデータ要求
				accessoryManager.write(commandPacket); 				// 送信実行								
				break;
			case MsrPower:
				// 1バッファ受信　60個
				text1.setTextColor(Color.YELLOW);
				text1.setText("電源");
				for(i=0; i<60; i++){
					Data[Counter] = commandPacket[i+2];				// データバッファ保存
					Counter++;
				}
				if(Counter >= MAXSIZE*2){							// 全データ受信完了
					for(i=0; i<Index; i++)
			    		PowerVolt[i] 	= (float)((float)(Data[2*i]*128+Data[2*i+1])*1.653*3.3)/1024;
					// 次のデータ要求
					Counter = 0;
					commandPacket[0] = MsrShunt;					// 最初のデータ要求
					accessoryManager.write(commandPacket); 			// 送信実行
				}
				else{
					commandPacket[0] = MsrPower;					// データ繰り返し要求
					accessoryManager.write(commandPacket); 			// 送信実行
				}								
				break;	
			case MsrShunt:
				text1.setText("抵抗");
				// 1バッファ受信　60個
				for(i=0; i<60; i++){
					Data[Counter] = commandPacket[i+2];				// データバッファ保存
					Counter++;
				}
				if(Counter >= MAXSIZE*2){							// 全データ受信完了
			    	for(i=0; i<Index; i++)							    	
			    		ShuntVolt[i] 	= (float)((float)(Data[2*i]*128+Data[2*i+1])*1.653*3.3)/1024;
			    	// 次のデータ要求
					Counter = 0;
					commandPacket[0] = MsrBattery;					// 最初のデータ要求
					accessoryManager.write(commandPacket); 			// 送信実行
				}
				else{
					commandPacket[0] = MsrShunt;					// データ繰り返し要求
					accessoryManager.write(commandPacket); 			// 送信実行
				}								
				break;				
			case MsrBattery:
				text1.setText("充電");
				// 1バッファ受信　60個
				for(i=0; i<60; i++){
					Data[Counter] = commandPacket[i+2];				// データバッファ保存
					Counter++;
				}
				if(Counter >= MAXSIZE*2){							// 全データ受信完了
			    	for(i=0; i<Index; i++)						
			    		BatteryVolt[i] 	= (float)((float)(Data[2*i]*128+Data[2*i+1])*1.456*3.3)/1024;
			    	// 次のデータ要求
					Counter = 0;
					commandPacket[0] = MsrDischarge;				// 最初のデータ要求
					accessoryManager.write(commandPacket); 			// 送信実行
				}
				else{
					commandPacket[0] = MsrBattery;					// データ繰り返し要求
					accessoryManager.write(commandPacket); 			// 送信実行
				}								
				break;	
			case MsrDischarge:
				text1.setText("放電");
				// 1バッファ受信　60個
				for(i=0; i<60; i++){
					Data[Counter] = commandPacket[i+2];				// データバッファ保存
					Counter++;
				}
				if(Counter >= MAXSIZE*2){							// 全データ受信完了
					Counter = 0;
			    	for(i=0; i<Index; i++){
			    		DischargeVolt[i]= (float)((float)(Data[2*i]*128+Data[2*i+1])*1.640*3.3)/1024;
			    	}
		    		// 電流計算 2000*0.8=1600
			    	for(i=0; i<Index; i++){
			    		ChargeCurrent[i] = (PowerVolt[i]-ShuntVolt[i])*1600;
			    		if(ChargeCurrent[i] < 0)
			    			ChargeCurrent[i] = 0;
			    	}	
			    	// 表示出力
			    	handler.post(new Runnable(){
						public void run(){			
							graph.invalidate();						// データグラフの再表示	
						}
					});				    	
				}
				else{
					commandPacket[0] = MsrDischarge;				// データ繰り返し要求
					accessoryManager.write(commandPacket); 			// 送信実行
				}								
				break;				 	
			default: break;						
		}	
    }
    
    /**** データ収集開始ボタンイベントの処理 *****/
    class ContStart implements OnClickListener{
    	public void onClick(View v){
    		// データ収集開始
	   		commandPacket[0] = START;								// 制御コマンド 
    		accessoryManager.write(commandPacket); 					// 送信実行 
    	}    		
    }

	/**** グラフを描画するクラス   ****/
	class MyView extends View{
		// Viewの初期化
		public MyView(Context context){
			super(context);
		}
		// グラフ描画実行メソッド
		public void onDraw(Canvas canvas)	{
	 		super.onDraw(canvas);
	 		Paint set_paint = new Paint();
	 		//背景色の設定	 		
			canvas.drawColor(Color.BLACK); 
			// 座標の表示 青色で表示			
			set_paint.setColor(Color.BLUE);
			set_paint.setStrokeWidth(1);
			for(i=0; i<=9; i++)										// 縦軸の表示　10本
				canvas.drawLine(19+i*80, 0, 19+i*80, 419, set_paint);
			for(i=0; i<6; i++)										// 横軸の表示　7本
				canvas.drawLine(19, i*80+20, 739, i*80+20, set_paint);
			// 外枠ライン白色で描画
			set_paint.setColor(Color.WHITE);
			set_paint.setStrokeWidth(2);   		
			canvas.drawLine(19, 0, 19, 419, set_paint);
			canvas.drawLine(19, 0, 739, 0, set_paint);
			canvas.drawLine(19, 419, 739, 419 ,set_paint);
			canvas.drawLine(734, 0, 734, 419, set_paint);			
			// 軸目盛の表示			
			set_paint.setAntiAlias(true);
			set_paint.setTextSize(16f);
			set_paint.setColor(Color.WHITE);
			for(i=0; i<9; i++)										// X座標目盛
	    		canvas.drawText(Integer.toString(i*20), 10+i*80, 437, set_paint);
			canvas.drawText("分", 715, 437, set_paint);
			for(i=1; i<=6; i++)										// Y座標目盛
				canvas.drawText(Integer.toString(i), 5, 424-i*80, set_paint);
			// グラフ説明表示
			set_paint.setColor(Color.RED);
			canvas.drawText("充電電流", 105, 410, set_paint);
			set_paint.setColor(Color.GREEN);
			canvas.drawText("充電側電池電圧", 200, 410, set_paint);	
			set_paint.setColor(Color.YELLOW);
			canvas.drawText("放電側電池電圧", 365, 410, set_paint);
			// 放電電流値表示
			canvas.drawText(Integer.toString(setPoint*70)+"mA", 500, 410, set_paint);
			// 実際のグラフの表示
  			for(i=1; i<Index; i++){
 				set_paint.setColor(Color.RED);
		 		canvas.drawLine(i+19, 419-ChargeCurrent[i-1], i+20,
		 						             419-ChargeCurrent[i], set_paint);
				set_paint.setColor(Color.GREEN);	
		 		canvas.drawLine(i+19, 419-BatteryVolt[i-1]*80, i+20,
		 								419-BatteryVolt[i]*80, set_paint);
				set_paint.setColor(Color.YELLOW);			
		 		canvas.drawLine(i+19, 419-DischargeVolt[i-1]*80, i+20,
		 								419-DischargeVolt[i]*80, set_paint);
/*
		 		set_paint.setColor(Color.CYAN);			
		 		canvas.drawLine(i+19, 419-PowerVolt[i-1]*80, i+20,
		 								419-PowerVolt[i]*80, set_paint);
				set_paint.setColor(Color.GRAY);			
		 		canvas.drawLine(i+19, 419-ShuntVolt[i-1]*80, i+20,
		 								419-ShuntVolt[i]*80, set_paint);
*/		 		
 			}
		}
    }    
    
}


