/*****************************************************
*  $B%j%A%&%`EECS=<EEJ|EE%^%M!<%8%c(B
* $B!!(BPIC24FJ64GB002$B$G(BUSB$B%[%9%H%b!<%I(B
*
*****************************************************/
/* $B%U%!%$%k$N%$%s%/%k!<%I(B */
#include "USB/usb.h"
#include "USB/usb_host_android.h"
#include "Compiler.h"
#include "HardwareProfile.h"

#define MAX_ALLOWED_CURRENT     (500)    // Maximum power we can supply in mA

/* $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B */
_CONFIG1(WINDIS_OFF & FWDTEN_OFF & ICS_PGx1 & GCP_OFF & JTAGEN_OFF)
_CONFIG2(POSCMOD_NONE & I2C1SEL_PRI & OSCIOFNC_OFF & FCKSM_CSDCMD & FNOSC_FRCPLL
		 & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
_CONFIG3(SOSCSEL_IO)

/* $B%9%F!<%HJQ?t$N@k8@(B */
typedef enum{
    DEVICE_NOT_CONNECTED,
    DEVICE_CONNECTED,
    RECEIVE,
    RECEIVE_WAIT,
    SEND,
    SEND_WAIT,
}AP_STATE;
volatile AP_STATE State;
/* $B%3%^%s%I$N@k8@Dj5A(B **/
typedef enum _AP_COMMAND{
    OKCHECK     = 0x01,
    START       = 0x02,
    MsrPower    = 0x03,
    MsrShunt    = 0x04,
    MsrBattery  = 0x05,
    MsrDischarge= 0x06,
    DISCONNECT  = 0x7F
}AP_COMMAND;
volatile AP_COMMAND Command;
/* $B%0%m!<%P%kJQ?tDj5A(B */
static void* device_handle = NULL;
static BOOL device_attached = FALSE;
static BYTE read_buffer[64];
static BYTE send_buffer[64];
static BYTE count, Block ,setCur;
unsigned int Value[5], Interval, Index;
float InVolt, OutVolt, BatVolt, LiVolt, OutCur;
BYTE UpMesg[17]  = "CHG xxxmA  x.xxV";
BYTE LowMesg[17] = "DIS x.xxV  xxxmA";
/*$B%G!<%?J]B8%P%C%U%!Dj5A(B 15sec*720 = 3Hour */
#define MAXSIZE 720
BYTE Power[MAXSIZE*2+2];
BYTE Shunt[MAXSIZE*2+2];
BYTE Battery[MAXSIZE*2+2];
BYTE Discharge[MAXSIZE*2+2];

/** $B%"%s%I%m%$%I@\B3MQ%Q%i%a!<%?(B **/
static char manufacturer[]	= "Microchip Design Lab";
static char model[] 		= "BatCharger";
static char description[] 	= "Battery Charger Board";
static char version[] 		= "1.0";
static char uri[] 		= "http://www.picfun.com";
static char serial[] 		= "N/A";
ANDROID_ACCESSORY_INFORMATION myDeviceInfo =
{
    manufacturer,	sizeof(manufacturer),
    model,    		sizeof(model),
    description,        sizeof(description),
    version,    	sizeof(version),
    uri,    		sizeof(uri),
    serial,    		sizeof(serial)
};

/** $B4X?t%W%m%H%?%$%T%s%0(B **/
void OffLine(void);
void Process(void);
unsigned int ADConv(unsigned int chnl);
void ftostring(int seisu, int shousu, float data, BYTE *buffer);

/*************$B!!%a%$%s4X?t(B ******************/
int main(void){
    int i;
    
    CLKDIV = 0x0020;			// 96MHz PLL On CPU 32MHz
    /* I/O$B=i4|2=(B */
    TRISA = 0x0013;
    TRISB = 0x5FFF;
    // ADC$B$N=i4|@_Dj(B
    AD1CON1 = 0x80E0;                   // Off , Auto Start
    AD1CON2 = 0x0000;                   // VDD,VSS
    AD1CON3 = 0x1F05;                   // 31TAD, 5TCY
    AD1CHS  = 0x0000;                   // AN0
    AD1PCFG = 0xFFCC;			// AN0,1,4,5
    AD1CSSL = 0x0000;                   // No Scan
    // $B%?%$%^(B2$B=i4|@_Dj(B
    PR2 = 62500;                        // 250msec
    IPC1bits.T2IP = 3;                  // Interrupt priority = 3
    T2CON = 0x0020;                     // Internal 1/64
    IFS0bits.T2IF = 0;
    IEC0bits.T2IE = 1;
    // CVR$B=i4|@_Dj(B
    CVRCON = 0x00E0;                    // Level 0
    // I2C$B$N=i4|@_Dj(B
    I2C1BRG = 0x9C;			// 100kHz@16MHz
    I2C1CON = 0x8000;			// I2C$B%$%M!<%V%k(B
    /* $B1U>=I=<(4o$N=i4|2=(B*/
    lcd_init();
    lcd_cmd(0x01);                      // $BA4>C5n(B
    lcd_str("Start Charger");
    setCur = 0;
    Index = 0;
    Block = 0;
    count = 0;
    for(i=0; i<MAXSIZE*2; i++){
        Power[i] = 0;
        Shunt[i] = 0;
        Battery[i] = 0;
        Discharge[i] = 0;
    }
    /* USB$B=i4|2=$H(BAP$B%9%?!<%H(B */
    State = DEVICE_NOT_CONNECTED;	// USB$B=i4|>uBV$K%j%;%C%H(B
    USBInitialize(0);			// USB$B=i4|2=(B
    AndroidAppStart(&myDeviceInfo);	// Android$B%"%/%;%5%j=i4|2=(B

    /************ $B%a%$%s%k!<%W!!(B****************************/
    while(1)	{
        DWORD size;
        BYTE errorCode, Result;

        OffLine();                                              // $B%9%$%C%A%A%'%C%/(B
        /*** USB$B%9%F!<%H4X?t<B9T(B ***/
        USBTasks();						// USB$BAw<u?.<B9T(B
        /* $B%G%?%C%A8!=P(B */
        if(device_attached == FALSE){				// $B%G%P%$%9L$@\B3$+!)(B
            LED0_Off();						// $BL\0u(BLED
            LED1_On();
            lcd_icon(3, 0);                                     // $B%"%$%3%s>C5n(B
            State = DEVICE_NOT_CONNECTED;			// $B=i4|>uBV$X(B
        }
        /***** $B%9%F!<%H$K=>$C$F=hM}<B9T(B ********/
        switch(State){
            case DEVICE_NOT_CONNECTED:                          // $B%G%P%$%9L$@\B3Cf(B
                /**** $B%"%?%C%A8!=P(B  ****/
                if(device_attached == TRUE){			// $B%"%?%C%A$5$l$?$+!)(B
                    LED0_On();					// $BL\0u(BLED
                    LED1_Off();
                    State = DEVICE_CONNECTED;			// $B@\B3=hM}$X(B
                }
                break;
            case DEVICE_CONNECTED:				// $B@\B33NG'(B
                lcd_icon(3, 1);                                 // $B%"%$%3%sE@Et(B
                send_buffer[0] = OKCHECK;                       // $B@\B33NG'1~Ez(B
                send_buffer[1] = 'O';                           // OK$B%a%C%;!<%8JVAw(B
                send_buffer[2] = 'K';
                count = 3;
                State = SEND;
                break;
            case RECEIVE:					// Android$B$+$i$N<u?.<B9T!!:GBg(B64$B%P%$%H<u?.(B
                Result = AndroidAppRead(device_handle, (BYTE*)&read_buffer, (DWORD)sizeof(read_buffer));
                if(Result == USB_SUCCESS)
                    State = RECEIVE_WAIT;			// $B<u?.40N;BT$A$X(B
                break;
            case RECEIVE_WAIT:					// $B<u?.40N;BT$A(B
                if(AndroidAppIsReadComplete(device_handle, &errorCode, &size) == TRUE){
                    if(errorCode == USB_SUCCESS)		// $B@5>o40N;$+!)(B
                        Process();				// $B%3%^%s%I=hM}<B9T8e<!$N%9%F!<%H$X(B
                    else
                        State = RECEIVE;			// $B0[>o$J$iL5;k$7$F<!$N<u?.$X(B
                }
                break;
            case SEND:						// $BAw?.<B9T!!I,MW%P%$%H?t$N$_Aw?.(B
                Result = AndroidAppWrite(device_handle,(BYTE*)&send_buffer, count);
                if(Result == USB_SUCCESS)
                    State = SEND_WAIT;				// $B@5>o$J$iAw?.40N;BT$A$X(B   
                 break;
            case SEND_WAIT:					// $BAw?.40N;BT$A(B
                if(AndroidAppIsWriteComplete(device_handle, &errorCode, &size) == TRUE)
                    State = RECEIVE;				// $B40N;$G<!$N<u?.$X(B
                break;
            default :
                State = DEVICE_NOT_CONNECTED;
                break;
        }
    }
}
/**********************************************************
* USB$B<u?.%3%^%s%I=hM}<B9T4X?t(B
***********************************************************/
void Process(void){
    int i;
    unsigned char temp[5];                          // $BJQ49%G!<%?0l;~3JG<%(%j%"(B

    switch(read_buffer[0]){                         // $B%3%^%s%I<hF@(B
        /* $B@\B33NG'MW5a$N>l9g(B */
        case OKCHECK:
            send_buffer[0] = OKCHECK;               // $B3NG'$+!)(B
            send_buffer[1] = 'O';                   // OK$B%a%C%;!<%8JVAw(B
            send_buffer[2] = 'K';
            count = 3;                              // $BAw?.%P%$%H?t%;%C%H(B
            State = SEND;                           // $BAw?.$X(B
            Block = 0;
            break;
        case START:                                 // $BI=<(3+;OMW5a(B
            Block = 0;
            send_buffer[0] = START;                 // $B1~Ez(B
            send_buffer[1] = (BYTE)(Index/128);     // $B%G!<%??tJVAw(B
            send_buffer[2] = (BYTE)(Index%128);
            send_buffer[3] = setCur;                // $BJ|EEEEN.@_DjCM(B
            count = 4;
            State = SEND;
            break;
        /* $B7WB,MW5a$N>l9g(B */
        case MsrPower:                              // $BEE8;EE05B,Dj(B
            send_buffer[0] = MsrPower;
            send_buffer[1] = 60;
            for(i=0; i<60; i++){                    // 60$B%P%$%H$4$HAw?.(B
                send_buffer[i+2] = Power[Block*60+i];
            }
            Block++;                                // $B%V%m%C%/%+%&%s%?99?7(B
            if(Block >= (MAXSIZE*2)/60){            //$B!!=*N;$+!)(B
                Block = 0;
            }
            count = 62;                             // $BAw?.%9%F!<%H$X(B
            State = SEND;
            break;
        case MsrShunt:                              // $B%7%c%s%HDq93EE05B,Dj(B
            send_buffer[0] = MsrShunt;
            send_buffer[1] = 60;
            for(i=0; i<60; i++){
                send_buffer[i+2] = Shunt[Block*60+i];
            }
            Block++;
            if(Block >= (MAXSIZE*2)/60){
                Block = 0;
            }
            count = 62;
            State = SEND;
            break; 
        case MsrBattery:                            // $B=<EEB&EECSEE05B,Dj(B
            send_buffer[0] = MsrBattery;
            send_buffer[1] = 60;
            for(i=0; i<60; i++){
                send_buffer[i+2] = Battery[Block*60+i];
            }
            Block++;
            if(Block >= (MAXSIZE*2)/60){
                Block = 0;
            }
            count = 62;
            State = SEND;
            break;
        case MsrDischarge:                          // $BJ|EEB&EECSEE05B,Dj(B
            send_buffer[0] = MsrDischarge;
            send_buffer[1] = 60;
            for(i=0; i<60; i++){
                send_buffer[i+2] = Discharge[Block*60+i];
            }
            Block++;
            if(Block >= (MAXSIZE*2)/60){
                Block = 0;
            }
            count = 62;
            State = SEND;
            break;            
        case DISCONNECT:
            State = DEVICE_NOT_CONNECTED;           // $B=i4|>uBV$X(B
            break;
        default :
            break;
    }
}

/*********************************************************
*  $B%?%$%^(B2$B3d$j9~$_=hM}4X?t(B
*$B!!J|EE!"=<EECf$N%G!<%?$r<}=8$7%P%C%U%!$K3JG<(B
**********************************************************/
void __attribute__((interrupt, no_auto_psv)) _T2Interrupt(void){
    IFS0bits.T2IF = 0;
    // $B%7%c%s%HDq93F~NOB&EE05B,Dj(B
    Value[0] = ADConv(1);                           // AN1
    InVolt = ((float)Value[0] * 1.653 * 3.3)/1024;
    // $B%7%c%s%HDq93=PNOB&EE05B,Dj(B
    Value[1] = ADConv(5);                           // AN5
    OutVolt = ((float)Value[1] * 1.653 * 3.3)/1024;
    // $B=<EEEEN.CM7W;;(B mA 500$B&8%7%c%s%HDq93(B
    OutCur = (InVolt - OutVolt)*2000;
    if(OutCur < 0)
        OutCur = 0;
    // $BEECSEE05B,Dj(B
    Value[2] = ADConv(0);                           // AN0
    // $BEE05$KJQ49!!<B5!J,05HfJd@5(B=1.470
    BatVolt = ((float)Value[2] * 1.456 * 3.30)/1024;
    // $B1U>=I=<(4o$KI=<((B
    ftostring(3, 0, OutCur, UpMesg + 4);
    ftostring(1, 2, BatVolt, UpMesg + 11);
    lcd_cmd(0x80);                                  // 1 line
    lcd_str(UpMesg);                                // $BI=<((B
    // $BEEN.CM$N3S@5$r$9$k:]$K$3$N%3%a%s%H$r$O$:$7$F(B
    // $B%7%c%s%HDq93$N(BIn$B$H(BOut$B$NEE05$r1U>=I=<(4o$KI=<($9$k(B    
//    ftostring(1,3, InVolt, LowMesg + 4);
//    ftostring(1,3, OutVolt, LowMesg + 11);
//    lcd_cmd(0xC0);
//    lcd_str(LowMesg);
    // $BJ|EEEE057WB,(B
    Value[3] = ADConv(4);                          // AN4
    // $BEE05$KJQ49(B
    LiVolt = ((float)Value[3] * 3.30 *1.64)/1024;
    if(LiVolt < 1.5){
        CVRCON = 0xE0;                              // 1.5V$B$GJ|EEDd;_(B
        setCur = 0;
    }
    // $BEEN.CM$N3S@5$r$9$k:]$K$3$3$r%3%a%s%H%"%&%H$9$k(B
    ftostring(1, 2, LiVolt, LowMesg + 4);
    ftostring(3, 0, (setCur*70), LowMesg+11);       // $BJ|EEEEN.CM$NI=<((B
    lcd_cmd(0xC0);
    lcd_str(LowMesg);
    // $B%G!<%?J]B8(B
    Interval++;
    if(Interval >= 60){                             // 15sec$B$4$H(B
        Interval = 0;
        if(Index < MAXSIZE){
            // $B%P%C%U%!3JG<(B
            Power[Index*2]   = (BYTE)(Value[0]/128);
            Power[Index*2+1] = (BYTE)(Value[0]%128);
            Shunt[Index*2]   = (BYTE)(Value[1]/128);
            Shunt[Index*2+1] = (BYTE)(Value[1]%128);
            Battery[Index*2]   = (BYTE)(Value[2]/128);
            Battery[Index*2+1] = (BYTE)(Value[2]%128);
            Discharge[Index*2]   = (BYTE)(Value[3]/128);
            Discharge[Index*2+1] = (BYTE)(Value[3]%128);
            Index++;
        }
    }
}

/**********************************************************
*  $B%*%U%i%$%sCf$N=hM}4X?t(B
*  $B%9%$%C%A$N%A%'%C%/(B
**********************************************************/
void OffLine(void){
    // $B=<J|EE$N3+;O(B
    if(S1 == 0){                                    // SW1$B%*%sBT$A(B
        EN = 1;                                     // $B=<EE(BIC$B%*%s(B
        lcd_cmd(0x01);
        lcd_str("Start"); 
        CVRCON = 0xE1;                              // 70mA
        setCur = 1;
        T2CONbits.TON = 1;                          // Timer2 start
        while(S1 == 0);
    }
    // $B=<J|EE$NDd;_(B
    if(S3 == 0){
        T2CONbits.TON = 0;                          // Timer2 stop
       EN = 0;
       CVRCON = 0x00E0;                             // $B%l%Y%k(B0
       setCur = 0;
       lcd_cmd(0x01);                               // $B1U>=I=<(4o%/%j%"(B
       lcd_str("Stop");
       while(S3 == 0);
    }
    // $BJ|EEEEN.$N@Z$jBX$(!!(B70,140,210,280,350,420,490mA
    if(S2 == 0){
        if(T2CONbits.TON == 1){                     // $BF0:nCf$+!)(B
            setCur++;                               // 1-7$B$G7+$jJV$7(B
            if(setCur > 7)
                setCur = 1;
            CVRCON = 0xE0 + setCur;                 // $BJ|EEEEN.@_Dj(B
        }
        while(S2 == 0);
   }
}

/********************************************************
* A/D$BJQ49<B9T4X?t(B 
*********************************************************/
unsigned int ADConv(unsigned int chnl){
    AD1CON1bits.ADON = 0;                       // $B$$$C$?$s(BADC$B%*%U(B
    AD1CHS = chnl;                              // $B%A%c%M%kA*Br(B
    AD1CON1bits.ADON = 1;                       // $B:F%9%?!<%H(B
    AD1CON1bits.SAMP = 1;                       // $BJQ493+;O(B
    while(AD1CON1bits.DONE == 0);               // $BJQ49=*N;BT$A(B
    return (ADC1BUF0);                          // $B7k2L$rJV$9(B
}

/***********************************
* Float$B$+$iJ8;zNs$XJQ49(B
* $B9g7WM-8z7e$O(B8$B7e0J2<$H$9$k$3$H(B
***********************************/
void ftostring(int seisu, int shousu, float data, BYTE *buffer)
{
    int i;
    long dumy;

    if(shousu != 0)				//$B>.?tIt7e$"$j$+(B
        buffer += seisu+shousu+1;		//$BA4BN7e?t!\>.?tE@(B
    else					//$B>.?tIt7e$J$7$N$H$-(B
        buffer += seisu + shousu;		//$BA4BN7e?t$N$_(B
    buffer--;					//$BG[Ns%]%$%s%?(B-1
    for(i=0; i<shousu; i++)			//$B>.?tIt$r@0?t$KJQ49(B
        data = data * 10;			//$B#1#0G\(B
    /// dumy$B$,%*!<%P!<%U%m!<$9$k$HJQ49IT2D(B($B#87e$,8B3&(B)
    dumy = (long) (data + 0.5);			//$B;M<N8^F~$7$F@0?t$KJQ49(B
    for(i=shousu; i>0; i--)	{		//$B>.?t7e?tJ,7+$jJV$7(B
        *buffer =(dumy % 10)+'0';		//$B?tCM$rJ8;z$KJQ493JG<(B
        buffer--;				//$B3JG<>l=j2<0L$+$i>e0L$X(B
        dumy /= 10;				//$B<!$N7e$X(B
    }
    if(shousu != 0) {				//$B>.?t7e(B0$B$J$i>.?tE@$J$7(B
        *buffer = '.';				//$B>.?tE@$r3JG<(B
        buffer--;				//$B%]%$%s%?(B-1
    }
    for(i=seisu; i>0; i--) {			//$B@0?t7eJ,7+$jJV$7(B
        *buffer = (dumy % 10)+'0';		//$B?tCM$rJ8;z$KJQ493JG<(B
        buffer--;				//$B%]%$%s%?(B-1
        dumy /= 10;				//$B<!$N7e$X(B
    }
    i = 0;					// $B%V%i%s%-%s%0=hM}(B
    buffer++;
    while((i<seisu-1)&&(*buffer == '0')){         // $B>e0L7e$,(B0$B$N4V(B
        *buffer = ' ';				// $B%V%i%s%/$KJQ49(B
        buffer++;
        i++;
    }
}

/****************************************************************************
*  USB$B%G!<%?%$%Y%s%H=hM}4X?t(B
*    BOOL USB_ApplicationDataEventHandler( BYTE address, USB_EVENT event, void *data, DWORD size )
***************************************************************************/
BOOL USB_ApplicationDataEventHandler( BYTE address, USB_EVENT event, void *data, DWORD size )
{
    return FALSE;
}
/****************************************************************************
*  USB$B%$%Y%s%H=hM}4X?t72(B
*    BOOL USB_ApplicationEventHandler( BYTE address, USB_EVENT event, void *data, DWORD size )
***************************************************************************/
BOOL USB_ApplicationEventHandler( BYTE address, USB_EVENT event, void *data, DWORD size )
{
    switch( event )
    {
        case EVENT_VBUS_REQUEST_POWER:
            // The data pointer points to a byte that represents the amount of power
            // requested in mA, divided by two.  If the device wants too much power,
            // we reject it.
            if (((USB_VBUS_POWER_EVENT_DATA*)data)->current <= (MAX_ALLOWED_CURRENT / 2))
            {
                return TRUE;
            }
             break;

        case EVENT_VBUS_RELEASE_POWER:
        case EVENT_HUB_ATTACH:
        case EVENT_UNSUPPORTED_DEVICE:
        case EVENT_CANNOT_ENUMERATE:
        case EVENT_CLIENT_INIT_ERROR:
        case EVENT_OUT_OF_MEMORY:
        case EVENT_UNSPECIFIED_ERROR:   	// This should never be generated.
        case EVENT_DETACH:                   // USB cable has been detached (data: BYTE, address of device)
        case EVENT_ANDROID_DETACH:
            device_attached = FALSE;
            return TRUE;
            break;

        // Android Specific events
        case EVENT_ANDROID_ATTACH:
            device_attached = TRUE;
            device_handle = data;
            return TRUE;

        default :
            break;
    }
    return FALSE;
}
